/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.jeri.internal.mux;

import java.io.IOException;

/**
 * An IOFuture represents an I/O operation that may or may not have
 * completed yet.
 *
 * @author	Sun Microsystems, Inc.
 * 
 */
final class IOFuture {

    private boolean done = false;
    private IOException exception = null;

    IOFuture() { }

    /**
     * Waits until the I/O operation has completed.  If this method
     * returns normally, then the I/O operation has completed
     * successfully.  If this method throws IOException, then the
     * I/O operation failed.
     *
     * REMIND: Maybe we should support a timeout here, as a paranoid
     * escape hatch; if this wait really takes a long time, something
     * has gone dreadfully wrong.  To a large extent, we're really
     * depending on someone's finally clause to make sure that pending
     * instances of this class always get notified somehow.
     *
     * @throws	IOException if the I/O operation failed
     *
     * @throws	InterruptedException if the current thread was
     * interrupted while waiting for the I/O to complete.
     */
    synchronized void waitUntilDone()
	throws IOException, InterruptedException
    {
	while (!done) {
	    wait();
	}
	if (exception != null) {
	    exception.fillInStackTrace();
	    throw exception;
	}
    }

    /**
     * Signals that this I/O operation has completed successfully.
     */
    synchronized void done() {
	assert !done;
	done = true;
	notifyAll();
    }

    /**
     * Signals that this I/O operation has failed (with details of the
     * failure in the given IOException).
     *
     * @param	e detail of the I/O operation's failure
     */
    synchronized void done(IOException e) {
	if (done) {
	    /*
	     * This shouldn't normally happen, but it's difficult to prevent
	     * in bizarre failure scenarios (like an OutOfMemoryError).
	     */
	    return;
	}
	if (e == null) {
	    throw new NullPointerException();
	}
	this.exception = e;
	done = true;
	notifyAll();
    }
}
